SystemOrganization addCategory: #MultiDimensionalEnumeration!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-for'!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-for-test'!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-blockAdaptor'!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-blockAdaptor-test'!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-test'!

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:57'!
multiDimensionalCollect: aBlockContext
	
	^MultiDimensionalCollect new
		domains: self;
		block: aBlockContext;
		run  ! !

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:58'!
multiDimensionalDo: aBlockContext 

	^MultiDimensionalDo new
		domains: self;
		block: aBlockContext;
		run.    
! !

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:58'!
multiDimensionalSelect: aBlockContext 

	^MultiDimensionalSelect new
		domains: self;
		block: aBlockContext;
		run.    ! !

TestCase subclass: #AdaptedMultiDimensionalEnumerationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-test'!

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:05'!
testCollect1

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4}.
	collect blockOfOneArrayArgument: [:arr| arr first*10 ].
	self assert: {10. 20. 30. 40} equals: collect run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:07'!
testCollect2

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7}.
	collect blockOfOneArrayArgument: [:arr | arr first*10+arr second].
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: collect run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:08'!
testCollect3

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	collect blockOfOneArrayArgument: [:arr| (arr first*100)+(arr second*10)+arr third].
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: collect run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:08'!
testDo1

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4}.
	tape := OrderedCollection new.
	do blockOfOneArrayArgument: [:arr| tape addLast: arr first*10 ].
	do run.
	self assert: {10. 20. 30. 40} equals: tape asArray.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:08'!
testDo2

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7}.
	tape := OrderedCollection new.
	do blockOfOneArrayArgument: [:arr | tape addLast: arr first*10+arr second].
	do run.
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: tape asArray.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:08'!
testDo3

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do blockOfOneArrayArgument: [:arr| tape addLast: (arr first*100)+(arr second*10)+arr third].
	do run.
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: tape asArray.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 00:04'!
testDoReturnsDomains

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do blockOfOneArrayArgument: [:arr| tape addLast: (arr first*100)+(arr second*10)+arr third].
	self assert: do domains equals: do run.! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:09'!
testSelect1

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4}.
	select blockOfOneArrayArgument: [:arr| (arr first rem: 3) = 0 ].
	self assert: {{3}} equals: select run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:09'!
testSelect2

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4. 2 to: 7}.
	select blockOfOneArrayArgument: [:arr | (arr first+arr second rem: 3) = 0 ].
	self assert: {{1 . 2}. {1 . 5}. {2 . 4}. {2 . 7}. {3. 3}. {3 . 6}. {4 . 2}. {4 . 5}} equals: select run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:12'!
testSelectedCollect

	| select |
	select := MultiDimensionalSelectedCollect new.
	select domains: {1 to: 4. 2 to: 7}.
	select collectingBlockOfOneArrayArgument: [:arr | (arr first*10)+arr second].
	select selectingBlock: [:num| (num rem: 3) = 0].  
	self assert: {12. 15. 24. 27. 33. 36. 42. 45} equals: select run.    ! !

TestCase subclass: #BlockArgumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-blockAdaptor-test'!

!BlockArgumentTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:53'!
testAdaptorBehavior
self assert: ((BlockOfAnyNumberArguments new blockOfOneArrayArgument: [:array| array first + array second]) valueWithArguments: {1. 2}) equals: 3.

! !

!BlockArgumentTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:56'!
testBasicBehavior
self assert: ([:a :b| a+b] value: 1 value: 2) equals: 3.
self assert: ([:a :b| a+b] valueWithArguments: {1. 2}) equals: 3.
self should: [[:a :b| a+b] value: {1. 2}] raise: Error.

self should: [[:array| array first + array second] value: 1 value: 2] raise: Error.
self should: [[:array| array first + array second] valueWithArguments: {1. 2}] raise: Error.
self assert: ([:array| array first + array second] value: {1. 2}) equals: 3.

! !

!BlockArgumentTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 19:51'!
testToArrayArg

	self assert: (([:a :b :c| String with: a with: b with: c] asArrayArgBlock) value: #($A $B $C)) equals: 'ABC'! !

!BlockArgumentTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 23:53'!
testToArrayArgToManyArgs
	|block|
	block := [:a :b :c| String with: a with: b with: c].
	self assert: block asArrayArgBlock asManyArgsBlock == block! !

!BlockArgumentTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 19:54'!
testToManyArgsBlock

	self assert: ([:array| array first + array second + array third ] asManyArgsBlock value: 100 value: 20 value: 3) equals: 123! !

!BlockArgumentTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 23:55'!
testToManyArgsToArrayArgBlock
	| block |
	block := [:array| array first + array second + array third ].
	self assert: block asManyArgsBlock asArrayArgBlock == block.! !

TestCase subclass: #ForStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-for-test'!

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 18:24'!
testDepth1
|sum f|
sum := 0.
f := ForStatement new.
f domain: (1 to: 3).
f loopBlock: [:a| sum := a + sum].
f run.
self assert: sum equals: 6.! !

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:14'!
testDepth1check
|sum f|
sum := 0.
f := ForStatement new.
f domain: (1 to: 3).
f checkingBlock: [:a| a odd].
f loopBlock: [:a| sum := a + sum].
f run.
self assert: sum equals: 4.! !

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:27'!
testDepth2
|sum f|
sum := OrderedCollection new.
f := ForStatement new.
f domain: (1 to: 10).
f checkingBlock: [:e| e = 5].

f subFor: 
	(ForStatement new 
		domain: (1 to: 3)).

f loopBlock: [:a :b| sum add: {a. b}].
f run.
self assert: sum equals: (OrderedCollection with: {5. 1} with: {5. 2}  with: {5. 3})! !

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:28'!
testDepth2check
|sum f|
sum := OrderedCollection new.
f := ForStatement new.
f domain: (1 to: 10).
f checkingBlock: [:e| e = 5].

f subFor: 
	(ForStatement new 
		domain: (1 to: 6); 
		checkingBlock: [:e|e=2]).

f loopBlock: [:a :b| sum add: {a. b}].
f run.
self assert: sum equals: (OrderedCollection with: {5. 2})! !

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:27'!
testDepth2checkTrue
|sum f|
sum := OrderedCollection new.
f := ForStatement new.
f domain: (1 to: 10).
f checkingBlock: [:e| e = 5].

f subFor: 
	(ForStatement new 
		domain: (1 to: 3); 
		checkingBlock: [:e|true]).

f loopBlock: [:a :b| sum add: {a. b}].
f run.
self assert: sum equals: (OrderedCollection with: {5. 1} with: {5. 2}  with: {5. 3})! !

TestCase subclass: #MultiDimensionalEnumerationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-test'!

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:11'!
testCollect1

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4}.
	collect block: [:x| x*10 ].
	self assert: {10. 20. 30. 40} equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 00:33'!
testCollect2

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7}.
	collect block: [:x :y | x*10+y].
	self assert: collect isCollectionBlockTypeOk.
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:15'!
testCollect3

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	collect block: [:x :y :z| (x*100)+(y*10)+z].
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 19:18'!
testDo1

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4}.
	tape := OrderedCollection new.
	do block: [:x| tape addLast: x*10 ].
	do run.
	self assert: {10. 20. 30. 40} equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 00:01'!
testDo2

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7}.
	tape := OrderedCollection new.
	do block: [:x :y | tape addLast: x*10+y].
	do run.
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 19:25'!
testDo3

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do block: [:x :y :z| tape addLast: (x*100)+(y*10)+z].
	do run.
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:00'!
testDoReturnsDomains

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do block: [:x :y :z| tape addLast: (x*100)+(y*10)+z].
	self assert: do domains equals: do run.! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:20'!
testSelect1

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4}.
	select block: [:x| (x rem: 3) = 0 ].
	self assert: {{3}} equals: select run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:22'!
testSelect2

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4. 2 to: 7}.
	select block: [:x :y | (x+y rem: 3) = 0 ].
	self assert: {{1 . 2}. {1 . 5}. {2 . 4}. {2 . 7}. {3. 3}. {3 . 6}. {4 . 2}. {4 . 5}} equals: select run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/29/2012 23:00'!
testSelectedCollect

	| select |
	select := MultiDimensionalSelectedCollect new.
	select domains: {1 to: 4. 2 to: 7}.
	select collectingBlock: [:x :y | (x*10)+y].
	select selectingBlock: [:num| (num rem: 3) = 0].  
	self assert: {12. 15. 24. 27. 33. 36. 42. 45} equals: select run.    ! !

!BlockClosure methodsFor: '*MultiDimensionalEnumeration-blockAdaptor' stamp: 'HwaJong 12/9/2012 19:52'!
asArrayArgBlock
	^BlockOfOneArrayArgument new blockOfAnyNumberArguments: self! !

!BlockClosure methodsFor: '*MultiDimensionalEnumeration-blockAdaptor' stamp: 'HwaJong 12/9/2012 19:56'!
asManyArgsBlock
	^BlockOfAnyNumberArguments new blockOfOneArrayArgument: self! !

Error subclass: #MultiDimensionalEnumerationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

Object subclass: #BlockOfAnyNumberArguments
	instanceVariableNames: 'blockOfOneArrayArgument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-blockAdaptor'!

!BlockOfAnyNumberArguments methodsFor: 'converting' stamp: 'HwaJong 12/9/2012 23:55'!
asArrayArgBlock
	^blockOfOneArrayArgument! !

!BlockOfAnyNumberArguments methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 19:53'!
blockOfOneArrayArgument: aBlockClosure 
blockOfOneArrayArgument := aBlockClosure ! !

!BlockOfAnyNumberArguments methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 19:57'!
value: object1 value: object2 value: object3 
	^blockOfOneArrayArgument value: {object1. object2. object3}! !

!BlockOfAnyNumberArguments methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:55'!
valueWithArguments: anArray
^blockOfOneArrayArgument value: anArray ! !

Object subclass: #BlockOfOneArrayArgument
	instanceVariableNames: 'blockOfAnyNumberArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-blockAdaptor'!

!BlockOfOneArrayArgument methodsFor: 'converting' stamp: 'HwaJong 12/10/2012 00:14'!
asArrayArgBlock
	^self! !

!BlockOfOneArrayArgument methodsFor: 'converting' stamp: 'HwaJong 12/9/2012 23:54'!
asManyArgsBlock
	^blockOfAnyNumberArguments! !

!BlockOfOneArrayArgument methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 17:17'!
blockOfAnyNumberArguments
	^ blockOfAnyNumberArguments! !

!BlockOfOneArrayArgument methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 17:17'!
blockOfAnyNumberArguments: aBlockClosure
	blockOfAnyNumberArguments := aBlockClosure
! !

!BlockOfOneArrayArgument methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 17:27'!
value: anArray
	^blockOfAnyNumberArguments valueWithArguments: anArray! !

!BlockOfOneArrayArgument methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 17:33'!
valueWithArguments: anArray
	^blockOfAnyNumberArguments valueWithArguments: anArray! !

Object subclass: #ForStatement
	instanceVariableNames: 'domain checkingBlock subFor loopPosition superFor loopBlockOfArrayArg objectInDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-for'!

!ForStatement methodsFor: 'self evaluating' stamp: 'HwaJong 1/8/2013 18:58'!
argumentsForLoopBlock
	| stream |
	stream := MQARArrayWritter onArrayOfSize: self depth.
	self nextPutArgumentsForLoopBlockOn: stream.
	^stream array! !

!ForStatement methodsFor: 'changing' stamp: 'HwaJong 12/8/2012 23:52'!
beLeafFor
	subFor := nil! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 11/29/2012 19:08'!
checkIsPass
	^ checkingBlock isNil or: [checkingBlock value: self objectInDomain]! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
checkingBlock
	^ checkingBlock! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
checkingBlock: anObject
	checkingBlock := anObject! !

!ForStatement methodsFor: 'self evaluating' stamp: 'HwaJong 1/8/2013 18:37'!
defaultObjectInDomain
	^ domain at: loopPosition! !

!ForStatement methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/8/2013 18:22'!
depth
	^superFor isNil 
		ifTrue: [ 1 ] 
		ifFalse: [ superFor depth + 1 ]! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
domain
	^ domain! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 1/8/2013 18:39'!
domain: anObject
	domain := anObject.
	objectInDomain := nil.! !

!ForStatement methodsFor: 'self evaluating' stamp: 'HwaJong 12/8/2012 23:39'!
domains
	^Array streamContents: [:stream| self putDomainsOn: stream ] ! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 1/8/2013 18:40'!
increaseLoopPositionBy1
	loopPosition := loopPosition + 1.
	objectInDomain := nil.! !

!ForStatement methodsFor: 'initialize-release' stamp: 'HwaJong 1/8/2013 18:39'!
initialize
super initialize.
loopPosition := 0.
objectInDomain := nil.! !

!ForStatement methodsFor: 'initialize-release' stamp: 'HwaJong 12/8/2012 23:57'!
initializeWithDomainStream: aReadStream 
	aReadStream atEnd
		ifTrue: [self shouldBeImplemented]
		ifFalse: [
			self domain: aReadStream next.
			aReadStream atEnd
				ifTrue: [self beLeafFor]
				ifFalse: [self subFor: ForStatement new.
					self subFor initializeWithDomainStream: aReadStream]
			]! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 11/29/2012 16:31'!
isLeafFor
^subFor isNil! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 11/29/2012 16:27'!
isTerminated
^domain size < loopPosition! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 00:13'!
loopBlock: aBlockClosure
	self loopBlockOfArrayArg: aBlockClosure asArrayArgBlock! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 00:31'!
loopBlockOfArrayArg
	^self isLeafFor 
		ifTrue: [loopBlockOfArrayArg]
		ifFalse: [subFor loopBlockOfArrayArg].
! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 00:30'!
loopBlockOfArrayArg: anObject
	self isLeafFor 
		ifTrue: [loopBlockOfArrayArg := anObject]
		ifFalse: [subFor loopBlockOfArrayArg: anObject].
	! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 11/29/2012 18:51'!
loopingHasNotStartedYet
	^ loopPosition = 0! !

!ForStatement methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/8/2013 18:13'!
nextPutArgumentsForLoopBlockOn: aWriteStream 
	superFor isNil 
		ifTrue: [ aWriteStream nextPut: self objectInDomain  ] 
		ifFalse: 
			[ superFor nextPutArgumentsForLoopBlockOn: aWriteStream.
			aWriteStream nextPut: self objectInDomain]! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 1/8/2013 18:38'!
objectInDomain
	^ objectInDomain setDefault: #defaultObjectInDomain for: self withSetter: #objectInDomain:! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 1/8/2013 18:38'!
objectInDomain: anObject
	objectInDomain := anObject! !

!ForStatement methodsFor: 'self evaluating' stamp: 'HwaJong 11/29/2012 17:00'!
positions
	^self isLeafFor 
		ifTrue: [{loopPosition}]
		ifFalse: [{loopPosition}, subFor positions]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 12/8/2012 23:41'!
putDomainsOn: aWriteStream 
	aWriteStream nextPut: domain.
	subFor isNil
		ifFalse: [subFor putDomainsOn: aWriteStream ]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:03'!
run
	self setLoopPositionTo1.
	[ self isTerminated ] whileFalse: [ self step ]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 1/8/2013 18:39'!
setLoopPositionTo1
	loopPosition := 1.
	objectInDomain := nil.! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 1/8/2013 18:34'!
step
	self isTerminated
		ifTrue: [ ^ self ].
	self loopingHasNotStartedYet
		ifTrue: [ self setLoopPositionTo1 ].
	self checkIsPass
		ifTrue: [ self stepWhenCheckPass ]
		ifFalse: [ self stepWhenCheckFail ]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:00'!
stepWhenCheckFail
	self increaseLoopPositionBy1! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:01'!
stepWhenCheckPass
	self isLeafFor
		ifTrue: [ self stepWhenCheckPassAndAtLeaf ]
		ifFalse: [ self stepWhenCheckPassAndHasSub ]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 12/10/2012 00:13'!
stepWhenCheckPassAndAtLeaf
	loopBlockOfArrayArg value: self argumentsForLoopBlock.
	self increaseLoopPositionBy1! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:01'!
stepWhenCheckPassAndHasSub
	subFor isTerminated
		ifTrue: [ 
			subFor initialize.
			self increaseLoopPositionBy1 ]
		ifFalse: [ subFor step ]! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
subFor
	^ subFor! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:30'!
subFor: anObject
	subFor := anObject.
	anObject superFor: self.! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:29'!
superFor
	^ superFor! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:29'!
superFor: anObject
	superFor := anObject! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 00:33'!
typeOfLoopBlockOk
	|bl|
	bl := self loopBlockOfArrayArg.
	(bl isKindOf: BlockOfOneArrayArgument) ifTrue: [^true].
	^bl numArgs = 1! !

Object subclass: #MultiDimensionalCollect
	instanceVariableNames: 'do outputStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalCollect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:07'!
block
	^do block! !

!MultiDimensionalCollect methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 00:29'!
block: aBlockClosure 
	| arrayArgBlock |
	arrayArgBlock := aBlockClosure asArrayArgBlock.
	do blockOfArrayArg: [:args| self putOnOutputStream: (arrayArgBlock value: args) ]! !

!MultiDimensionalCollect methodsFor: 'accessing' stamp: 'HwaJong 12/8/2012 23:15'!
blockOfOneArrayArgument: aBlockClosure 
self block: (BlockOfAnyNumberArguments new blockOfOneArrayArgument: aBlockClosure)! !

!MultiDimensionalCollect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:08'!
domains

	^do domains! !

!MultiDimensionalCollect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:08'!
domains: anArray 
	do domains: anArray! !

!MultiDimensionalCollect methodsFor: 'initialize-release' stamp: 'HwaJong 12/9/2012 11:33'!
initialize 
super initialize.
do := MultiDimensionalDo new.! !

!MultiDimensionalCollect methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 00:25'!
isCollectionBlockTypeOk
	^do isCollectionBlockTypeOk! !

!MultiDimensionalCollect methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 17:23'!
putOnOutputStream: anObject

	outputStream nextPut: anObject! !

!MultiDimensionalCollect methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 17:24'!
run

	outputStream := WriteStream on: (Array new: ((self domains collect: #size) reduce: [:a :b| a*b])).
	do run.
	^outputStream contents.! !

Object subclass: #MultiDimensionalDo
	instanceVariableNames: 'for'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalDo methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:40'!
block
	^for loopBlock! !

!MultiDimensionalDo methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:40'!
block: aBlockClosure 

	for loopBlock: aBlockClosure.! !

!MultiDimensionalDo methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 23:45'!
blockOfArrayArg: aBlockClosure 
	for loopBlockOfArrayArg: aBlockClosure! !

!MultiDimensionalDo methodsFor: 'accessing' stamp: 'HwaJong 12/8/2012 23:15'!
blockOfOneArrayArgument: aBlockClosure 
self block: (BlockOfAnyNumberArguments new blockOfOneArrayArgument: aBlockClosure)! !

!MultiDimensionalDo methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:40'!
domains

	^ for domains! !

!MultiDimensionalDo methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:40'!
domains: anArray 

	for := ForStatement new.
	for initializeWithDomainStream: anArray readStream! !

!MultiDimensionalDo methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 00:26'!
isCollectionBlockTypeOk
	^for typeOfLoopBlockOk! !

!MultiDimensionalDo methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 17:10'!
run

	for run.
	^self domains! !

Object subclass: #MultiDimensionalSelect
	instanceVariableNames: 'do outputStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalSelect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:35'!
block
^do block! !

!MultiDimensionalSelect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 17:44'!
block: booleanBlockOfArgs 
	| booleanBlockOfArray selectingBlockOfArrayArg selectingBlockOfManyArgs |
	booleanBlockOfArray := BlockOfOneArrayArgument new blockOfAnyNumberArguments: booleanBlockOfArgs.
	selectingBlockOfArrayArg := [:args| (booleanBlockOfArray valueWithArguments: args) ifTrue: [self putOnOutputStream: args] ].
	selectingBlockOfManyArgs := BlockOfAnyNumberArguments new blockOfOneArrayArgument: selectingBlockOfArrayArg.
	do block: selectingBlockOfManyArgs.! !

!MultiDimensionalSelect methodsFor: 'accessing' stamp: 'HwaJong 12/8/2012 23:15'!
blockOfOneArrayArgument: aBlockClosure 
self block: (BlockOfAnyNumberArguments new blockOfOneArrayArgument: aBlockClosure)! !

!MultiDimensionalSelect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:34'!
domains

	^do domains! !

!MultiDimensionalSelect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:34'!
domains: anArray 

	do domains: anArray! !

!MultiDimensionalSelect methodsFor: 'initialize-release' stamp: 'HwaJong 12/9/2012 11:34'!
initialize 
super initialize.
do := MultiDimensionalDo new.! !

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 17:36'!
putOnOutputStream: anObject

	outputStream nextPut: anObject! !

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 17:45'!
run

	outputStream := WriteStream on: Array new.
	do run.
	^outputStream contents.! !

Object subclass: #MultiDimensionalSelectedCollect
	instanceVariableNames: 'do outputStream selectingBlock collectingBlockArrayArg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'HwaJong 12/8/2012 23:15'!
blockOfOneArrayArgument: aBlockClosure 
self block: (BlockOfAnyNumberArguments new blockOfOneArrayArgument: aBlockClosure)! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 00:00'!
collectingBlock: aBlock

	self collectingBlockArrayArg: aBlock asArrayArgBlock! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 23:58'!
collectingBlockArrayArg: aBlockClosure
	collectingBlockArrayArg := aBlockClosure
! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 00:48'!
collectingBlockOfOneArrayArgument: aBlock

	"[:a :b :c|  a * b  - c  ]"
	collectingBlockArrayArg := aBlock ! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:36'!
domains

	^do domains! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'HwaJong 12/9/2012 11:36'!
domains: anArray 

	do domains: anArray! !

!MultiDimensionalSelectedCollect methodsFor: 'initialize-release' stamp: 'HwaJong 12/9/2012 11:36'!
initialize
super initialize.
do := MultiDimensionalDo new.! !

!MultiDimensionalSelectedCollect methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/9/2012 18:11'!
putOnOutputStream: anObject

	outputStream nextPut: anObject! !

!MultiDimensionalSelectedCollect methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 00:05'!
run

	| bs |
	outputStream := WriteStream on: Array new.

	do blockOfArrayArg: [:args| |obj|
		obj := collectingBlockArrayArg value: args.
		(selectingBlock value: obj)
			ifTrue: [self putOnOutputStream: obj]].
	
	do run.
	^outputStream contents.! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 00:04'!
selectingBlock: aBlockClosure

	self assert: [ aBlockClosure numArgs = 1 ].
	selectingBlock := aBlockClosure! !
